<?php
/**
 * ServiceLevelAgreementApi
 * PHP version 7.4
 *
 * @category Class
 * @package  SLIS\Adapter\Hub
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * slis hub
 *
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 0.7.4
 * Contact: dev@slis.io
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 6.1.0-SNAPSHOT
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace SLIS\Adapter\Hub\Api;

use GuzzleHttp\Client;
use GuzzleHttp\ClientInterface;
use GuzzleHttp\Exception\ConnectException;
use GuzzleHttp\Exception\RequestException;
use GuzzleHttp\Psr7\MultipartStream;
use GuzzleHttp\Psr7\Request;
use GuzzleHttp\RequestOptions;
use SLIS\Adapter\Hub\ApiException;
use SLIS\Adapter\Hub\Configuration;
use SLIS\Adapter\Hub\HeaderSelector;
use SLIS\Adapter\Hub\ObjectSerializer;

/**
 * ServiceLevelAgreementApi Class Doc Comment
 *
 * @category Class
 * @package  SLIS\Adapter\Hub
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */
class ServiceLevelAgreementApi
{
    /**
     * @var ClientInterface
     */
    protected $client;

    /**
     * @var Configuration
     */
    protected $config;

    /**
     * @var HeaderSelector
     */
    protected $headerSelector;

    /**
     * @var int Host index
     */
    protected $hostIndex;

    /**
     * @param ClientInterface $client
     * @param Configuration   $config
     * @param HeaderSelector  $selector
     * @param int             $hostIndex (Optional) host index to select the list of hosts if defined in the OpenAPI spec
     */
    public function __construct(
        ClientInterface $client = null,
        Configuration $config = null,
        HeaderSelector $selector = null,
        $hostIndex = 0
    ) {
        $this->client = $client ?: new Client();
        $this->config = $config ?: new Configuration();
        $this->headerSelector = $selector ?: new HeaderSelector();
        $this->hostIndex = $hostIndex;
    }

    /**
     * Set the host index
     *
     * @param int $hostIndex Host index (required)
     */
    public function setHostIndex($hostIndex): void
    {
        $this->hostIndex = $hostIndex;
    }

    /**
     * Get the host index
     *
     * @return int Host index
     */
    public function getHostIndex()
    {
        return $this->hostIndex;
    }

    /**
     * @return Configuration
     */
    public function getConfig()
    {
        return $this->config;
    }

    /**
     * Operation apiFirewallsServiceLevelAgreementGetSubresourceFirewallSubresource
     *
     * Retrieves a Firewall resource.
     *
     * @param  string $uuid Firewall identifier (required)
     *
     * @throws \SLIS\Adapter\Hub\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \SLIS\Adapter\Hub\Model\ServiceLevelAgreementJsonldReadSlaRead
     */
    public function apiFirewallsServiceLevelAgreementGetSubresourceFirewallSubresource($uuid)
    {
        list($response) = $this->apiFirewallsServiceLevelAgreementGetSubresourceFirewallSubresourceWithHttpInfo($uuid);
        return $response;
    }

    /**
     * Operation apiFirewallsServiceLevelAgreementGetSubresourceFirewallSubresourceWithHttpInfo
     *
     * Retrieves a Firewall resource.
     *
     * @param  string $uuid Firewall identifier (required)
     *
     * @throws \SLIS\Adapter\Hub\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \SLIS\Adapter\Hub\Model\ServiceLevelAgreementJsonldReadSlaRead, HTTP status code, HTTP response headers (array of strings)
     */
    public function apiFirewallsServiceLevelAgreementGetSubresourceFirewallSubresourceWithHttpInfo($uuid)
    {
        $request = $this->apiFirewallsServiceLevelAgreementGetSubresourceFirewallSubresourceRequest($uuid);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    (int) $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? (string) $e->getResponse()->getBody() : null
                );
            } catch (ConnectException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    (int) $e->getCode(),
                    null,
                    null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        (string) $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    (string) $response->getBody()
                );
            }

            switch($statusCode) {
                case 200:
                    if ('\SLIS\Adapter\Hub\Model\ServiceLevelAgreementJsonldReadSlaRead' === '\SplFileObject') {
                        $content = $response->getBody(); //stream goes to serializer
                    } else {
                        $content = (string) $response->getBody();
                        if ('\SLIS\Adapter\Hub\Model\ServiceLevelAgreementJsonldReadSlaRead' !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, '\SLIS\Adapter\Hub\Model\ServiceLevelAgreementJsonldReadSlaRead', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
            }

            $returnType = '\SLIS\Adapter\Hub\Model\ServiceLevelAgreementJsonldReadSlaRead';
            if ($returnType === '\SplFileObject') {
                $content = $response->getBody(); //stream goes to serializer
            } else {
                $content = (string) $response->getBody();
                if ($returnType !== 'string') {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\SLIS\Adapter\Hub\Model\ServiceLevelAgreementJsonldReadSlaRead',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation apiFirewallsServiceLevelAgreementGetSubresourceFirewallSubresourceAsync
     *
     * Retrieves a Firewall resource.
     *
     * @param  string $uuid Firewall identifier (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function apiFirewallsServiceLevelAgreementGetSubresourceFirewallSubresourceAsync($uuid)
    {
        return $this->apiFirewallsServiceLevelAgreementGetSubresourceFirewallSubresourceAsyncWithHttpInfo($uuid)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation apiFirewallsServiceLevelAgreementGetSubresourceFirewallSubresourceAsyncWithHttpInfo
     *
     * Retrieves a Firewall resource.
     *
     * @param  string $uuid Firewall identifier (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function apiFirewallsServiceLevelAgreementGetSubresourceFirewallSubresourceAsyncWithHttpInfo($uuid)
    {
        $returnType = '\SLIS\Adapter\Hub\Model\ServiceLevelAgreementJsonldReadSlaRead';
        $request = $this->apiFirewallsServiceLevelAgreementGetSubresourceFirewallSubresourceRequest($uuid);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    if ($returnType === '\SplFileObject') {
                        $content = $response->getBody(); //stream goes to serializer
                    } else {
                        $content = (string) $response->getBody();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        (string) $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'apiFirewallsServiceLevelAgreementGetSubresourceFirewallSubresource'
     *
     * @param  string $uuid Firewall identifier (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    public function apiFirewallsServiceLevelAgreementGetSubresourceFirewallSubresourceRequest($uuid)
    {

        // verify the required parameter 'uuid' is set
        if ($uuid === null || (is_array($uuid) && count($uuid) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $uuid when calling apiFirewallsServiceLevelAgreementGetSubresourceFirewallSubresource'
            );
        }

        $resourcePath = '/firewalls/{uuid}/service_level_agreement';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;



        // path params
        if ($uuid !== null) {
            $resourcePath = str_replace(
                '{' . 'uuid' . '}',
                ObjectSerializer::toPathValue($uuid),
                $resourcePath
            );
        }


        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/ld+json', 'application/json', 'text/html']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/ld+json', 'application/json', 'text/html'],
                []
            );
        }

        // for model (json/xml)
        if (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $formParamValueItems = is_array($formParamValue) ? $formParamValue : [$formParamValue];
                    foreach ($formParamValueItems as $formParamValueItem) {
                        $multipartContents[] = [
                            'name' => $formParamName,
                            'contents' => $formParamValueItem
                        ];
                    }
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = ObjectSerializer::buildQuery($formParams);
            }
        }

        // this endpoint requires API key authentication
        $apiKey = $this->config->getApiKeyWithPrefix('Authorization');
        if ($apiKey !== null) {
            $headers['Authorization'] = $apiKey;
        }

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $operationHost = $this->config->getHost();
        $query = ObjectSerializer::buildQuery($queryParams);
        return new Request(
            'GET',
            $operationHost . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation deleteServiceLevelAgreementItem
     *
     * Removes the ServiceLevelAgreement resource.
     *
     * @param  string $uuid Resource identifier (required)
     *
     * @throws \SLIS\Adapter\Hub\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return void
     */
    public function deleteServiceLevelAgreementItem($uuid)
    {
        $this->deleteServiceLevelAgreementItemWithHttpInfo($uuid);
    }

    /**
     * Operation deleteServiceLevelAgreementItemWithHttpInfo
     *
     * Removes the ServiceLevelAgreement resource.
     *
     * @param  string $uuid Resource identifier (required)
     *
     * @throws \SLIS\Adapter\Hub\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of null, HTTP status code, HTTP response headers (array of strings)
     */
    public function deleteServiceLevelAgreementItemWithHttpInfo($uuid)
    {
        $request = $this->deleteServiceLevelAgreementItemRequest($uuid);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    (int) $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? (string) $e->getResponse()->getBody() : null
                );
            } catch (ConnectException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    (int) $e->getCode(),
                    null,
                    null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        (string) $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    (string) $response->getBody()
                );
            }

            return [null, $statusCode, $response->getHeaders()];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
            }
            throw $e;
        }
    }

    /**
     * Operation deleteServiceLevelAgreementItemAsync
     *
     * Removes the ServiceLevelAgreement resource.
     *
     * @param  string $uuid Resource identifier (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function deleteServiceLevelAgreementItemAsync($uuid)
    {
        return $this->deleteServiceLevelAgreementItemAsyncWithHttpInfo($uuid)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation deleteServiceLevelAgreementItemAsyncWithHttpInfo
     *
     * Removes the ServiceLevelAgreement resource.
     *
     * @param  string $uuid Resource identifier (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function deleteServiceLevelAgreementItemAsyncWithHttpInfo($uuid)
    {
        $returnType = '';
        $request = $this->deleteServiceLevelAgreementItemRequest($uuid);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    return [null, $response->getStatusCode(), $response->getHeaders()];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        (string) $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'deleteServiceLevelAgreementItem'
     *
     * @param  string $uuid Resource identifier (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    public function deleteServiceLevelAgreementItemRequest($uuid)
    {

        // verify the required parameter 'uuid' is set
        if ($uuid === null || (is_array($uuid) && count($uuid) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $uuid when calling deleteServiceLevelAgreementItem'
            );
        }

        $resourcePath = '/sla/{uuid}';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;



        // path params
        if ($uuid !== null) {
            $resourcePath = str_replace(
                '{' . 'uuid' . '}',
                ObjectSerializer::toPathValue($uuid),
                $resourcePath
            );
        }


        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                []
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                [],
                []
            );
        }

        // for model (json/xml)
        if (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $formParamValueItems = is_array($formParamValue) ? $formParamValue : [$formParamValue];
                    foreach ($formParamValueItems as $formParamValueItem) {
                        $multipartContents[] = [
                            'name' => $formParamName,
                            'contents' => $formParamValueItem
                        ];
                    }
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = ObjectSerializer::buildQuery($formParams);
            }
        }

        // this endpoint requires API key authentication
        $apiKey = $this->config->getApiKeyWithPrefix('Authorization');
        if ($apiKey !== null) {
            $headers['Authorization'] = $apiKey;
        }

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $operationHost = $this->config->getHost();
        $query = ObjectSerializer::buildQuery($queryParams);
        return new Request(
            'DELETE',
            $operationHost . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation getServiceLevelAgreementCollection
     *
     * Retrieves the collection of ServiceLevelAgreement resources.
     *
     * @param  int $page The collection page number (optional, default to 1)
     *
     * @throws \SLIS\Adapter\Hub\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \SLIS\Adapter\Hub\Model\GetServiceLevelAgreementCollection200Response
     */
    public function getServiceLevelAgreementCollection($page = 1)
    {
        list($response) = $this->getServiceLevelAgreementCollectionWithHttpInfo($page);
        return $response;
    }

    /**
     * Operation getServiceLevelAgreementCollectionWithHttpInfo
     *
     * Retrieves the collection of ServiceLevelAgreement resources.
     *
     * @param  int $page The collection page number (optional, default to 1)
     *
     * @throws \SLIS\Adapter\Hub\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \SLIS\Adapter\Hub\Model\GetServiceLevelAgreementCollection200Response, HTTP status code, HTTP response headers (array of strings)
     */
    public function getServiceLevelAgreementCollectionWithHttpInfo($page = 1)
    {
        $request = $this->getServiceLevelAgreementCollectionRequest($page);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    (int) $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? (string) $e->getResponse()->getBody() : null
                );
            } catch (ConnectException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    (int) $e->getCode(),
                    null,
                    null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        (string) $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    (string) $response->getBody()
                );
            }

            switch($statusCode) {
                case 200:
                    if ('\SLIS\Adapter\Hub\Model\GetServiceLevelAgreementCollection200Response' === '\SplFileObject') {
                        $content = $response->getBody(); //stream goes to serializer
                    } else {
                        $content = (string) $response->getBody();
                        if ('\SLIS\Adapter\Hub\Model\GetServiceLevelAgreementCollection200Response' !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, '\SLIS\Adapter\Hub\Model\GetServiceLevelAgreementCollection200Response', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
            }

            $returnType = '\SLIS\Adapter\Hub\Model\GetServiceLevelAgreementCollection200Response';
            if ($returnType === '\SplFileObject') {
                $content = $response->getBody(); //stream goes to serializer
            } else {
                $content = (string) $response->getBody();
                if ($returnType !== 'string') {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\SLIS\Adapter\Hub\Model\GetServiceLevelAgreementCollection200Response',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation getServiceLevelAgreementCollectionAsync
     *
     * Retrieves the collection of ServiceLevelAgreement resources.
     *
     * @param  int $page The collection page number (optional, default to 1)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function getServiceLevelAgreementCollectionAsync($page = 1)
    {
        return $this->getServiceLevelAgreementCollectionAsyncWithHttpInfo($page)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation getServiceLevelAgreementCollectionAsyncWithHttpInfo
     *
     * Retrieves the collection of ServiceLevelAgreement resources.
     *
     * @param  int $page The collection page number (optional, default to 1)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function getServiceLevelAgreementCollectionAsyncWithHttpInfo($page = 1)
    {
        $returnType = '\SLIS\Adapter\Hub\Model\GetServiceLevelAgreementCollection200Response';
        $request = $this->getServiceLevelAgreementCollectionRequest($page);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    if ($returnType === '\SplFileObject') {
                        $content = $response->getBody(); //stream goes to serializer
                    } else {
                        $content = (string) $response->getBody();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        (string) $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'getServiceLevelAgreementCollection'
     *
     * @param  int $page The collection page number (optional, default to 1)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    public function getServiceLevelAgreementCollectionRequest($page = 1)
    {


        $resourcePath = '/sla';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // query params
        $queryParams = array_merge($queryParams, ObjectSerializer::toQueryValue(
            $page,
            'page', // param base name
            'integer', // openApiType
            'form', // style
            false, // explode
            false // required
        ) ?? []);




        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/ld+json', 'application/json', 'text/html']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/ld+json', 'application/json', 'text/html'],
                []
            );
        }

        // for model (json/xml)
        if (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $formParamValueItems = is_array($formParamValue) ? $formParamValue : [$formParamValue];
                    foreach ($formParamValueItems as $formParamValueItem) {
                        $multipartContents[] = [
                            'name' => $formParamName,
                            'contents' => $formParamValueItem
                        ];
                    }
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = ObjectSerializer::buildQuery($formParams);
            }
        }

        // this endpoint requires API key authentication
        $apiKey = $this->config->getApiKeyWithPrefix('Authorization');
        if ($apiKey !== null) {
            $headers['Authorization'] = $apiKey;
        }

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $operationHost = $this->config->getHost();
        $query = ObjectSerializer::buildQuery($queryParams);
        return new Request(
            'GET',
            $operationHost . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation getServiceLevelAgreementItem
     *
     * Retrieves a ServiceLevelAgreement resource.
     *
     * @param  string $uuid Resource identifier (required)
     *
     * @throws \SLIS\Adapter\Hub\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \SLIS\Adapter\Hub\Model\ServiceLevelAgreementJsonldReadSlaRead
     */
    public function getServiceLevelAgreementItem($uuid)
    {
        list($response) = $this->getServiceLevelAgreementItemWithHttpInfo($uuid);
        return $response;
    }

    /**
     * Operation getServiceLevelAgreementItemWithHttpInfo
     *
     * Retrieves a ServiceLevelAgreement resource.
     *
     * @param  string $uuid Resource identifier (required)
     *
     * @throws \SLIS\Adapter\Hub\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \SLIS\Adapter\Hub\Model\ServiceLevelAgreementJsonldReadSlaRead, HTTP status code, HTTP response headers (array of strings)
     */
    public function getServiceLevelAgreementItemWithHttpInfo($uuid)
    {
        $request = $this->getServiceLevelAgreementItemRequest($uuid);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    (int) $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? (string) $e->getResponse()->getBody() : null
                );
            } catch (ConnectException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    (int) $e->getCode(),
                    null,
                    null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        (string) $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    (string) $response->getBody()
                );
            }

            switch($statusCode) {
                case 200:
                    if ('\SLIS\Adapter\Hub\Model\ServiceLevelAgreementJsonldReadSlaRead' === '\SplFileObject') {
                        $content = $response->getBody(); //stream goes to serializer
                    } else {
                        $content = (string) $response->getBody();
                        if ('\SLIS\Adapter\Hub\Model\ServiceLevelAgreementJsonldReadSlaRead' !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, '\SLIS\Adapter\Hub\Model\ServiceLevelAgreementJsonldReadSlaRead', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
            }

            $returnType = '\SLIS\Adapter\Hub\Model\ServiceLevelAgreementJsonldReadSlaRead';
            if ($returnType === '\SplFileObject') {
                $content = $response->getBody(); //stream goes to serializer
            } else {
                $content = (string) $response->getBody();
                if ($returnType !== 'string') {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\SLIS\Adapter\Hub\Model\ServiceLevelAgreementJsonldReadSlaRead',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation getServiceLevelAgreementItemAsync
     *
     * Retrieves a ServiceLevelAgreement resource.
     *
     * @param  string $uuid Resource identifier (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function getServiceLevelAgreementItemAsync($uuid)
    {
        return $this->getServiceLevelAgreementItemAsyncWithHttpInfo($uuid)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation getServiceLevelAgreementItemAsyncWithHttpInfo
     *
     * Retrieves a ServiceLevelAgreement resource.
     *
     * @param  string $uuid Resource identifier (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function getServiceLevelAgreementItemAsyncWithHttpInfo($uuid)
    {
        $returnType = '\SLIS\Adapter\Hub\Model\ServiceLevelAgreementJsonldReadSlaRead';
        $request = $this->getServiceLevelAgreementItemRequest($uuid);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    if ($returnType === '\SplFileObject') {
                        $content = $response->getBody(); //stream goes to serializer
                    } else {
                        $content = (string) $response->getBody();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        (string) $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'getServiceLevelAgreementItem'
     *
     * @param  string $uuid Resource identifier (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    public function getServiceLevelAgreementItemRequest($uuid)
    {

        // verify the required parameter 'uuid' is set
        if ($uuid === null || (is_array($uuid) && count($uuid) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $uuid when calling getServiceLevelAgreementItem'
            );
        }

        $resourcePath = '/sla/{uuid}';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;



        // path params
        if ($uuid !== null) {
            $resourcePath = str_replace(
                '{' . 'uuid' . '}',
                ObjectSerializer::toPathValue($uuid),
                $resourcePath
            );
        }


        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/ld+json', 'application/json', 'text/html']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/ld+json', 'application/json', 'text/html'],
                []
            );
        }

        // for model (json/xml)
        if (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $formParamValueItems = is_array($formParamValue) ? $formParamValue : [$formParamValue];
                    foreach ($formParamValueItems as $formParamValueItem) {
                        $multipartContents[] = [
                            'name' => $formParamName,
                            'contents' => $formParamValueItem
                        ];
                    }
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = ObjectSerializer::buildQuery($formParams);
            }
        }

        // this endpoint requires API key authentication
        $apiKey = $this->config->getApiKeyWithPrefix('Authorization');
        if ($apiKey !== null) {
            $headers['Authorization'] = $apiKey;
        }

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $operationHost = $this->config->getHost();
        $query = ObjectSerializer::buildQuery($queryParams);
        return new Request(
            'GET',
            $operationHost . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation postServiceLevelAgreementCollection
     *
     * Creates a ServiceLevelAgreement resource.
     *
     * @param  \SLIS\Adapter\Hub\Model\ServiceLevelAgreementJsonldWriteSlaWrite $serviceLevelAgreementJsonldWriteSlaWrite The new ServiceLevelAgreement resource (required)
     *
     * @throws \SLIS\Adapter\Hub\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \SLIS\Adapter\Hub\Model\ServiceLevelAgreementJsonldReadSlaRead
     */
    public function postServiceLevelAgreementCollection($serviceLevelAgreementJsonldWriteSlaWrite)
    {
        list($response) = $this->postServiceLevelAgreementCollectionWithHttpInfo($serviceLevelAgreementJsonldWriteSlaWrite);
        return $response;
    }

    /**
     * Operation postServiceLevelAgreementCollectionWithHttpInfo
     *
     * Creates a ServiceLevelAgreement resource.
     *
     * @param  \SLIS\Adapter\Hub\Model\ServiceLevelAgreementJsonldWriteSlaWrite $serviceLevelAgreementJsonldWriteSlaWrite The new ServiceLevelAgreement resource (required)
     *
     * @throws \SLIS\Adapter\Hub\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \SLIS\Adapter\Hub\Model\ServiceLevelAgreementJsonldReadSlaRead, HTTP status code, HTTP response headers (array of strings)
     */
    public function postServiceLevelAgreementCollectionWithHttpInfo($serviceLevelAgreementJsonldWriteSlaWrite)
    {
        $request = $this->postServiceLevelAgreementCollectionRequest($serviceLevelAgreementJsonldWriteSlaWrite);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    (int) $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? (string) $e->getResponse()->getBody() : null
                );
            } catch (ConnectException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    (int) $e->getCode(),
                    null,
                    null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        (string) $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    (string) $response->getBody()
                );
            }

            switch($statusCode) {
                case 201:
                    if ('\SLIS\Adapter\Hub\Model\ServiceLevelAgreementJsonldReadSlaRead' === '\SplFileObject') {
                        $content = $response->getBody(); //stream goes to serializer
                    } else {
                        $content = (string) $response->getBody();
                        if ('\SLIS\Adapter\Hub\Model\ServiceLevelAgreementJsonldReadSlaRead' !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, '\SLIS\Adapter\Hub\Model\ServiceLevelAgreementJsonldReadSlaRead', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
            }

            $returnType = '\SLIS\Adapter\Hub\Model\ServiceLevelAgreementJsonldReadSlaRead';
            if ($returnType === '\SplFileObject') {
                $content = $response->getBody(); //stream goes to serializer
            } else {
                $content = (string) $response->getBody();
                if ($returnType !== 'string') {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 201:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\SLIS\Adapter\Hub\Model\ServiceLevelAgreementJsonldReadSlaRead',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation postServiceLevelAgreementCollectionAsync
     *
     * Creates a ServiceLevelAgreement resource.
     *
     * @param  \SLIS\Adapter\Hub\Model\ServiceLevelAgreementJsonldWriteSlaWrite $serviceLevelAgreementJsonldWriteSlaWrite The new ServiceLevelAgreement resource (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function postServiceLevelAgreementCollectionAsync($serviceLevelAgreementJsonldWriteSlaWrite)
    {
        return $this->postServiceLevelAgreementCollectionAsyncWithHttpInfo($serviceLevelAgreementJsonldWriteSlaWrite)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation postServiceLevelAgreementCollectionAsyncWithHttpInfo
     *
     * Creates a ServiceLevelAgreement resource.
     *
     * @param  \SLIS\Adapter\Hub\Model\ServiceLevelAgreementJsonldWriteSlaWrite $serviceLevelAgreementJsonldWriteSlaWrite The new ServiceLevelAgreement resource (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function postServiceLevelAgreementCollectionAsyncWithHttpInfo($serviceLevelAgreementJsonldWriteSlaWrite)
    {
        $returnType = '\SLIS\Adapter\Hub\Model\ServiceLevelAgreementJsonldReadSlaRead';
        $request = $this->postServiceLevelAgreementCollectionRequest($serviceLevelAgreementJsonldWriteSlaWrite);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    if ($returnType === '\SplFileObject') {
                        $content = $response->getBody(); //stream goes to serializer
                    } else {
                        $content = (string) $response->getBody();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        (string) $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'postServiceLevelAgreementCollection'
     *
     * @param  \SLIS\Adapter\Hub\Model\ServiceLevelAgreementJsonldWriteSlaWrite $serviceLevelAgreementJsonldWriteSlaWrite The new ServiceLevelAgreement resource (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    public function postServiceLevelAgreementCollectionRequest($serviceLevelAgreementJsonldWriteSlaWrite)
    {

        // verify the required parameter 'serviceLevelAgreementJsonldWriteSlaWrite' is set
        if ($serviceLevelAgreementJsonldWriteSlaWrite === null || (is_array($serviceLevelAgreementJsonldWriteSlaWrite) && count($serviceLevelAgreementJsonldWriteSlaWrite) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $serviceLevelAgreementJsonldWriteSlaWrite when calling postServiceLevelAgreementCollection'
            );
        }

        $resourcePath = '/sla';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;





        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/ld+json', 'application/json', 'text/html']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/ld+json', 'application/json', 'text/html'],
                ['application/ld+json', 'application/json', 'text/html']
            );
        }

        // for model (json/xml)
        if (isset($serviceLevelAgreementJsonldWriteSlaWrite)) {
            if ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode(ObjectSerializer::sanitizeForSerialization($serviceLevelAgreementJsonldWriteSlaWrite));
            } else {
                $httpBody = $serviceLevelAgreementJsonldWriteSlaWrite;
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $formParamValueItems = is_array($formParamValue) ? $formParamValue : [$formParamValue];
                    foreach ($formParamValueItems as $formParamValueItem) {
                        $multipartContents[] = [
                            'name' => $formParamName,
                            'contents' => $formParamValueItem
                        ];
                    }
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = ObjectSerializer::buildQuery($formParams);
            }
        }

        // this endpoint requires API key authentication
        $apiKey = $this->config->getApiKeyWithPrefix('Authorization');
        if ($apiKey !== null) {
            $headers['Authorization'] = $apiKey;
        }

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $operationHost = $this->config->getHost();
        $query = ObjectSerializer::buildQuery($queryParams);
        return new Request(
            'POST',
            $operationHost . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Create http client option
     *
     * @throws \RuntimeException on file opening failure
     * @return array of http client options
     */
    protected function createHttpClientOption()
    {
        $options = [];
        if ($this->config->getDebug()) {
            $options[RequestOptions::DEBUG] = fopen($this->config->getDebugFile(), 'a');
            if (!$options[RequestOptions::DEBUG]) {
                throw new \RuntimeException('Failed to open the debug file: ' . $this->config->getDebugFile());
            }
        }

        return $options;
    }
}
